Bug 974005 - Review Request: nodejs-packaging - RPM Macros and Utilities for Node.js Packaging
Review Request: nodejs-packaging - RPM Macros and Utilities for Node.js Packa...
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
All Linux
medium Severity medium
: ---
: ---
Assigned To: Jamie Nguyen
Fedora Extras Quality Assurance
Depends On:
Blocks: nodejs-reviews
  Show dependency treegraph
Reported: 2013-06-13 05:24 EDT by T.C. Hollingsworth
Modified: 2013-07-26 14:13 EDT (History)
3 users (show)

See Also:
Fixed In Version: libuv-0.10.12-1.el6
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2013-07-20 05:41:15 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
jamielinux: fedora‑review+
limburgher: fedora‑cvs+

Attachments (Terms of Use)

  None (edit)
Description T.C. Hollingsworth 2013-06-13 05:24:21 EDT
Spec: http://patches.fedorapeople.org/node-core/nodejs-packaging.spec
SRPM: http://patches.fedorapeople.org/node-core/nodejs-packaging-1-1.fc19.src.rpm
Koji: http://koji.fedoraproject.org/koji/taskinfo?taskID=5498547
FAS:  patches
This package contains RPM macros and other utilities useful for packaging
Node.js modules and applications in RPM-based distributions.

Here's a nodejs that works with this (nodejs-devel < 0.9.9 will conflict):
Comment 1 Jamie Nguyen 2013-06-20 18:19:04 EDT
Package Review

[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed

===== MUST items =====

[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Package complies to the Packaging Guidelines
[x]: License field in the package spec file matches the actual license.
     Note: There is no build directory. Running licensecheck on vanilla
     upstream sources. No licenses found. Please check the source files for
     licenses manually.
[x]: Package consistently uses macro is (instead of hard-coded directory
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Fully versioned dependency in subpackages, if present.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).

===== SHOULD items =====

[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

[x]: Large data in /usr/share should live in a noarch subpackage if package is
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).

Checking: nodejs-packaging-1-1.fc20.noarch.rpm
nodejs-packaging.noarch: W: spelling-error Summary(en_US) js -> dis, ks, j
nodejs-packaging.noarch: W: spelling-error %description -l en_US js -> dis, ks, j
nodejs-packaging.noarch: W: only-non-binary-in-usr-lib
1 packages and 0 specfiles checked; 0 errors, 3 warnings.

Rpmlint (installed packages)
# rpmlint nodejs-packaging
nodejs-packaging.noarch: W: spelling-error Summary(en_US) js -> dis, ks, j
nodejs-packaging.noarch: W: spelling-error %description -l en_US js -> dis, ks, j
nodejs-packaging.noarch: W: only-non-binary-in-usr-lib
1 packages and 0 specfiles checked; 0 errors, 3 warnings.
# echo 'rpmlint-done:'

nodejs-packaging (rpmlib, GLIBC filtered):


Source checksums
https://fedorahosted.org/released/nodejs-packaging/nodejs-packaging-fedora-1.tar.xz :
  CHECKSUM(SHA256) this package     : 67131e024b4eb703bfad944a1611dcfc321719d4bc4486720472cafff90f740b
  CHECKSUM(SHA256) upstream package : 67131e024b4eb703bfad944a1611dcfc321719d4bc4486720472cafff90f740b

Generated by fedora-review 0.4.1 (b2e211f) last change: 2013-04-29
Buildroot used: fedora-rawhide-x86_64
Command line :/bin/fedora-review -m fedora-rawhide-x86_64 -r -n nodejs-packaging-1-1.fc19.src.rpm
Comment 2 Jamie Nguyen 2013-06-20 18:23:00 EDT
I think 'rpm' should be explicitly Required. The packaging guidelines don't seem to list 'rpm' as one that can be ignored, but at the same time I can't imagine the dire state a Fedora system would be in if rpm was missing... I suppose it couldn't harm to add it anyway though, since the package is using /etc/rpm and /usr/lib/rpm directories.

Otherwise, package approved!
Comment 3 T.C. Hollingsworth 2013-06-20 21:01:27 EDT
I decided to make it require redhat-rpm-config, because things can be glitchy without that.  It Requires rpm, solving that issue.

Also, in nodejs-0.10.12-1 I moved ownership of /usr/share/node from nodejs-devel to nodejs so I could put the multiple version list file in there, instead of creating a directory just for this purpose.


Spec: http://patches.fedorapeople.org/node-core/nodejs-packaging.spec
SRPM: http://patches.fedorapeople.org/node-core/nodejs-packaging-2-1.fc19.src.rpm

* Fri Jun 21 2013 T.C. Hollingsworth <tchollingsworth@gmail.com> - 2-1
- move multiple version list to /usr/share/node
- bump nodejs Requires to 0.10.12
- add Requires: redhat-rpm-config
Comment 4 T.C. Hollingsworth 2013-06-20 21:03:38 EDT
New Package SCM Request
Package Name: nodejs-packaging
Short Description: RPM Macros and Utilities for Node.js Packaging
Owners: patches sgallagh mrunge
Branches: f19 f18 el6
InitialCC: jamielinux humaton
Comment 5 Gwyn Ciesla 2013-06-21 08:03:38 EDT
Git done (by process-git-requests).
Comment 6 Fedora Update System 2013-07-10 07:04:59 EDT
libuv-0.10.12-1.fc19,nodejs-packaging-3-1.fc19,nodejs-0.10.13-1.fc19 has been submitted as an update for Fedora 19.
Comment 7 Fedora Update System 2013-07-10 07:05:04 EDT
libuv-0.10.12-1.fc18,nodejs-packaging-3-1.fc18,nodejs-0.10.13-1.fc18 has been submitted as an update for Fedora 18.
Comment 8 Fedora Update System 2013-07-10 07:35:19 EDT
libuv-0.10.12-1.el6,nodejs-packaging-3-1.el6,nodejs-0.10.13-1.el6 has been submitted as an update for Fedora EPEL 6.
Comment 9 Fedora Update System 2013-07-10 18:06:34 EDT
Package libuv-0.10.12-1.el6, nodejs-packaging-3-1.el6, nodejs-0.10.13-1.el6:
* should fix your issue,
* was pushed to the Fedora EPEL 6 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=epel-testing libuv-0.10.12-1.el6 nodejs-packaging-3-1.el6 nodejs-0.10.13-1.el6'
as soon as you are able to.
Please go to the following url:
then log in and leave karma (feedback).
Comment 10 Fedora Update System 2013-07-20 05:41:15 EDT
libuv-0.10.12-1.fc18, nodejs-packaging-3-1.fc18, nodejs-0.10.13-1.fc18 has been pushed to the Fedora 18 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 11 Fedora Update System 2013-07-20 05:43:32 EDT
libuv-0.10.12-1.fc19, nodejs-packaging-3-1.fc19, nodejs-0.10.13-1.fc19 has been pushed to the Fedora 19 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 12 Fedora Update System 2013-07-26 14:13:10 EDT
libuv-0.10.12-1.el6, nodejs-packaging-3-1.el6, nodejs-0.10.13-1.el6 has been pushed to the Fedora EPEL 6 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.